//+------------------------------------------------------------------+
//|                                                e-MultiThread.mq5 |
//+------------------------------------------------------------------+
input int Threads=1; //   
input int MagicNumber=0;

//  
input int PatternLen  = 1440;   //    ()
input int PrognozeLen = 60;     //       
input int HistoryLen  = 375000; //      

input double Lots=0.1;
//+------------------------------------------------------------------+
class IndData
  {
public:
   int               ts,te;
   datetime          start_time;
   double            prognoze,rating;
  };

IndData Calc[];
double CurPattern[];
double Prognoze;
int  HistPatternBarStart;
int  ExistsPrognozeLen;
uint TicksStart,TicksEnd;
//+------------------------------------------------------------------+
#include <ThreadCalc.mqh>
#include <Trade\Trade.mqh>
//+------------------------------------------------------------------+
int OnInit()
  {

   double rates[];

//=== ,     
   int HistNeed=HistoryLen+Threads+PatternLen+
                PatternLen+PrognozeLen-1;
   if(TerminalInfoInteger(TERMINAL_MAXBARS)<HistNeed)
     {
      Print("   \".   \"     ",
            HistNeed,"   ");
      return(1);
     }
   while(Bars(_Symbol,_Period)<HistNeed)
     {
      Print("   (",Bars(_Symbol,_Period),
            ")  , ...");
      CopyClose(_Symbol,_Period,0,HistNeed,rates);
     }
   Print("   : ",Bars(_Symbol,_Period));

//===      
   if(Threads>1)
     {
      GlobalVarPrefix="MultiThread_"+IntegerToString(MagicNumber)+"_";
      GlobalVariablesDeleteAll(GlobalVarPrefix);

      ArrayResize(Calc,Threads);

      //     
      int HistPartLen=MathCeil(HistoryLen/Threads);
      //      
      int HistPartLenPlus=HistPartLen+PatternLen+PrognozeLen-1;

      string s;
      int snum=0;
      //    
      for(int t=0; t<Threads; t++)
        {
         //   -   ,
         //          
         do
            s=SymbolName(snum++,false);
         while(s==_Symbol);

         int handle=iCustom(s,_Period,"i-Thread",
                            GlobalVarPrefix,t,_Symbol,PatternLen,
                            PatternLen+t*HistPartLen,HistPartLenPlus);

         if(handle==INVALID_HANDLE) return(1);
         Print(" ,  ",s,", handle ",handle);
        }
     }

   return(0);
  }
//+------------------------------------------------------------------+
void OnTick()
  {
   TicksStart=GetTickCount();

//     
   while(CopyClose(_Symbol,_Period,0,PatternLen,CurPattern)
         <PatternLen) Sleep(1000);

//    ,   ""
//       
//    
   CalcPrognozeLen();

//      -
//       
   FindHistoryPrognoze();

//    
   Trade();

   TicksEnd=GetTickCount();
//    
   PrintReport();
  }
//+------------------------------------------------------------------+
void FindHistoryPrognoze()
  {
   Prognoze=0;
   double MaxRating;

   if(Threads>1)
     {
      //--------------------------------------
      //   
      //--------------------------------------
      //      
      for(int t=0; t<Threads; t++)
        {
         //    
         SetParam(t,"PrognozeLen",ExistsPrognozeLen);
         //  " "
         SetParam(t,"Query");
        }

      for(int t=0; t<Threads; t++)
        {
         //  
         while(!ParamExists(t,"Answer"))
            Sleep(100);
         DelParam(t,"Answer");

         //  
         double progn        = GetParam(t, "Prognoze");
         double rating       = GetParam(t, "Rating");
         datetime time[];
         int start=GetParam(t,"PatternStart");
         CopyTime(_Symbol,_Period,start,1,time);
         Calc [t].prognoze   = progn;
         Calc [t].rating     = rating;
         Calc [t].start_time = time[0];
         Calc [t].ts         = GetParam(t, "TS");
         Calc [t].te         = GetParam(t, "TE");

         //   
         if((t==0) || (rating>MaxRating))
           {
            MaxRating = rating;
            Prognoze  = progn;
           }
        }
     }
   else
     {
      //----------------------------
      //   
      //----------------------------
      //    ,   
      FindPrognoze(_Symbol,CurPattern,0,HistoryLen,ExistsPrognozeLen,
                   Prognoze,MaxRating,HistPatternBarStart);
     }
  }
//+------------------------------------------------------------------+
void CalcPrognozeLen()
  {
   ExistsPrognozeLen=PrognozeLen;

//    , , 
//      
   if(PositionSelect(_Symbol))
     {
      datetime postime=PositionGetInteger(POSITION_TIME);
      datetime curtime,time[];
      CopyTime(_Symbol,_Period,0,1,time);
      curtime=time[0];
      CopyTime(_Symbol,_Period,curtime,postime,time);
      int poslen=ArraySize(time);
      if(poslen<PrognozeLen)
         ExistsPrognozeLen=PrognozeLen-poslen;
      else
         ExistsPrognozeLen=0;
     }
  }
//+------------------------------------------------------------------+
void Trade()
  {

//   ,    
   if(PositionSelect(_Symbol))
     {
      long type=PositionGetInteger(POSITION_TYPE);
      bool close=false;
      if((type == POSITION_TYPE_BUY)  && (Prognoze <= 0)) close = true;
      if((type == POSITION_TYPE_SELL) && (Prognoze >= 0)) close = true;
      if(close)
        {
         CTrade trade;
         trade.PositionClose(_Symbol);
        }
     }

//   ,    
   if((Prognoze!=0) && (!PositionSelect(_Symbol)))
     {
      CTrade trade;
      if(Prognoze > 0) trade.Buy (Lots);
      if(Prognoze < 0) trade.Sell(Lots);
     }
  }
//+------------------------------------------------------------------+
void PrintReport()
  {
   Print("------------");
   Print(":   ",TicksStart,
         ",   ",TicksEnd,
         ",  () ",TicksEnd-TicksStart);
   Print(":   ",ExistsPrognozeLen," ");

   if(Threads>1)
     {
      for(int t=0; t<Threads; t++)
        {
         Print(" ",t+1,
               ":  ", Calc[t].prognoze,
               ",  ", Calc[t].rating,
               ",   ",TimeToString(Calc[t].start_time),"  ");
         Print(" ",t+1,
               ":   ",  Calc[t].ts,
               ",   ",   Calc[t].te,
               ",  () ",Calc[t].te-Calc[t].ts);
        }
     }
   else
     {
      Print("  ");
      datetime time[];
      CopyTime(_Symbol,_Period,HistPatternBarStart,1,time);
      Print(":   ",TimeToString(time[0]),"  ");
     }

   Print(":  ",Prognoze);
   Print("------------");
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//     
   if(Threads>1)
      for(int t=0; t<Threads; t++)
         SetParam(t,"End");
  }
//+------------------------------------------------------------------+